# 需要配合的其他业务模块

以下各个模块需要配合相关工作，以保证分享有礼项目能够正常运行。

- ### **会员认证流程自动跳转**

  约定参数规格，支持请求方在页面请求中带入参数，在会员认证流程结束后跳转到参数中对应的页面。

  注意：需要在页面栈中将会员认证流程的页面全部杀掉，防止用户回到上一步。

- #### 链接小工具

  - **支持添加自定义路径链接**

    目前支持自定义H5链接，但不支持自定义小程序路径（商户小程序）。在本次分享有礼的迭代中，必须支持该功能，才能保证业务正常进行。

    链接小工具的链接类型中新增【自定义路径】选项，位置排在【会员功能】和【第三方小程序】之间

    管理员选择该项后，有以下几项配置项

    - **进入条件**

      设置用户是否需要认证后才能访问，和【H5页面】的链接类型中的“进入条件”配置项逻辑一样。

    - **链接名称**

      不是页面的title，而是链接的名称，装修页面中有些地方需要显示该超链接的页面名称，则需要调用该字段。

      和【H5页面】的链接类型中的“名称”配置项逻辑一样。

    - **小程序路径**

      目标小程序页面路径，和【H5页面】的链接类型中的“网址”配置项逻辑一样。

      

  - **支持会员认证流程自定义回调页面**

    当用户选择【链接类型：会员功能-会员认证】时新增回跳页面的配置项，详见原型

    - **请求页面**

      即在哪个页面请求跳转的会员认证流程，认证完后就回哪个页面。

    - **指定页面**

      手动选择一个页面，认证完后跳转到该页面。这部分的交互以配置链接的交互一样，只是前端处理的时候需要实现页面自动转发，不需要用户点击。

- #### 游戏页面的会员认证请求要加回跳参数

  上面讲到，要支持用户配置会员认证链接时自定义回调页面，其实也就是在相应的请求中加参数。

  但是，游戏中引导用户去会员认证的链接不是用户手动配置的，是系统设计死的，因此本次迭代中需要将所有游戏页面的会员认证请求加参数，支持会员认证结束后回到请求页面。

  包括以下这些游戏：

  - 大转盘

  - 刮刮卡

  - 拼图游戏

  - 找你马

  - 口令福利

    

- ### **事件通知**

  - **服务号关注事件**

    当有用户关注服务号后，发送事件通知给分享有礼，通知中至少包含以下业务参数：

    - **openID：**用于确定受邀人身份，千万不要用memberid，因为memberid在后续用户的合并中可能被删除。
    - **时间：**以yyyy-mm-dd hh:mm:ss传入用户的关注时间
    - **二维码参数：**将二维码中的参数原封不动给分享有礼模块即可

  - **页面访问事件**

    当有用户访问自定义页面，发送事件通知给分享有礼，通知中至少包含以下业务参数：

    - **openID：**用于确定受邀人身份，千万不要用memberid，因为memberid在后续用户的合并中可能被删除。
    - **时间：**以yyyy-mm-dd hh:mm:ss传入用户访问的时间
    - **页面ID：**用于确认该页面访问的事件是否需要进行分享有礼的业务判断
    - **邀请人参数：**将请求该页面时带入的参数原封不同给分享有礼模块即可

  - **会员认证事件**

    当有用户完成会员认证，发送事件通知给分享有礼，通知中至少包含以下业务参数：

    - **openID：**用于确定受邀人身份，千万不要用memberid，因为memberid在后续用户的合并中可能被删除。
    - **时间：**以yyyy-mm-dd hh:mm:ss传入事件发生的事件

  - ##### 游戏参与事件

    当用户参与游戏成功后，发送事件通知给分享有礼，通知中至少包含以下业务参数：

    - **openID**：用于确定受邀人身份，千万不要用memberid，因为memberid在后续用户的合并中可能被删除。

    - **时间**：以yyyy-mm-dd hh:mm:ss传入事件发生的事件

    - **游戏计划ID**：用于确认该游戏的事件是否需要进行分享有礼的业务判断

    - **邀请人参数**：

      将session中的参数原封不同给分享有礼模块即可

      为了实现该需要，需要游戏页面在加载时把接收到的请求参数写入session，若请求参数为空，则需要清空session。

      包括以下这些游戏：

      - 大转盘
      - 刮刮卡
      - 拼图游戏
      - 找你马
      - 口令福利

  - **卡券领取事件**

    当有用户领取了卡券，发送事件通知给分享有礼，通知中至少包含以下业务参数：

    - **openID：**用于确定受邀人身份，千万不要用memberid，因为memberid在后续用户的合并中可能被删除。
    - **时间：**以yyyy-mm-dd hh:mm:ss传入事件发生的事件
    - **卡券ID**：用于确认该卡券领取的要进行分享有礼的业务判断

  - **订单事件**

    当有用户有新增订单（不管订单类型，只要是订单就发通知），发送事件通知给分享有礼。

    门店订单的非会员订单不用通知，商城订单只需要传支付成功的消费订单和退款成功的退款订单。
    
    通知中至少包含以下业务参数：
    
    - **openID：**用于确定受邀人身份，千万不要用memberid，因为memberid在后续用户的合并中可能被删除。
    - **时间：**以yyyy-mm-dd hh:mm:ss传入事件发生的事件
    - **订单编号：**订单自身流水号
    - **原始流水号**：退货订单、退换货订单填入，收银订单为空即可
    - **成交商品件数：**订单中商品成交件数之和（负数的话就是减）
    - **成交金额：**订单的rprice字段值
    - **渠道：**开发人员自己约定，能识别渠道来源是门店、达摩微商城还是微盟微商城就好
    - **消费门店code：**订单中消费门店的code，商城订单为空

  

- ### 请求接口

  - ##### 提供客服消息接口

    提供分享有礼模块调用，给用户发送小程序卡片。

  - **提供积分冻结时长参数**

    支持积分变更接口中（针对积分新增场景）支持冻结时长参数，对新增的积分做冻结期的控制。

  - ##### 提供积分追扣接口
  
    提供分享有礼模块调用，当用户出现退款时，调用该接口并带入积分明细ID（流水号），便能将原先的获取积分进行追扣。
    
  - **积分明细中【事由】字段的数据字典扩充**
  
    - **积分新增**
  
      新增”分享有礼“，凡是由分享有礼请求的积分新增，都是属于该来源。
  
    - **积分扣减**
  
      新增“分享有礼追扣”，凡是由分享有礼请求的积分追扣，都是属于该来源。
  
